#include <bits/stdc++.h>

using namespace std;
#define endl "\n"

vector<int> V(200000);
int l1,r1;
int n,c,q;

int sretna_slava()
{
   int maxi=0,maks=0,k=0;
   for (int i=0;i<n;i++)
   {
       maks=maks+V[i];
       if (maks < 0)
       {
           maks = 0;
           k=i+1;
       }
       else if (maxi < maks)
       {
           maxi = maks;
           l1=k;
           r1=i;
       }
   }
   return maxi;
}

int main()
{
    int i,one=0,zero=0,l,r,j;
    string str;
    cin>>n>>c>>q>>str;
    for(i=0;i<n;i++)
    {
        if(str[i]=='1')one++;
        else zero++;
    }
    if(c==n)
    {
        while(q--)
        {
            cin>>l>>r;
            for(i=l-1;i<r;i++)
            {
                if(str[i]=='1')
                {
                    str[i]='0';
                    one--;
                }
                else
                {
                    str[i]='1';
                    one++;
                }
            }
            cout<<one<<endl;
        }
    }
    else if(c==1)
    {
        while(q--)
        {
            int counter=0;
            cin>>l>>r;
            for(i=l-1;i<r;i++)
            {
                if(str[i]=='1')str[i]='0';
                else str[i]='1';
            }
            for(i=0;i<n;i++)
            {
                if(str[i]=='1')
                {
                    while(i<n && str[i]=='1')i++;
                    counter++;
                }
            }
            cout<<counter<<endl;
        }
    }
    else
    {
        while(q--)
        {
            cin>>l>>r;
            for(i=l-1;i<r;i++)
            {
                if(str[i]=='1')str[i]='0';
                else str[i]='1';
            }
            int cost=0;
            for(i=0;i<n;i++)
            {
                if(str[i]=='1')V[i]=1;
                else V[i]=-1;
            }
            while(sretna_slava()>c)
            {
                for(i=l1;i<=r1;i++)
                {
                    if(V[i]==1)V[i]=-1;
                    else V[i]=1;
                }
                cost+=c;
            }
            for(i=0;i<n;i++)if(V[i]==1)cost++;
            cout<<cost<<endl;
        }
    }
    return 0;
}